package com.example;

import akka.actor.typed.Behavior;
import akka.actor.typed.javadsl.AbstractBehavior;
import akka.actor.typed.javadsl.ActorContext;
import akka.actor.typed.javadsl.Behaviors;
import akka.actor.typed.javadsl.Receive;

public class Actor extends AbstractBehavior<Actor.Message> {

    String name;
    Expression expression;
    public interface Message{}

    public record StartMessage(Expression expression) implements Message{}

    private Actor(ActorContext<Message> context, String name){
        super(context);
        this.name = name;
    }

    public static Behavior<Actor.Message> create(String name){
        return Behaviors.setup(context -> new Actor(context, name));
    }

    @Override
    public Receive<Actor.Message> createReceive(){
        return newReceiveBuilder()
                .onMessage(StartMessage.class, this::onStartMessage)
                .build();
    }

    private Behavior<Message> onStartMessage(StartMessage message){
        this.expression = message.expression;
        //Wenn initial nur Val übergeben wird -> einfach ausgeben
        if(expression instanceof Expression.Val){
            System.out.println(((Expression.Val) expression).inner());

        }
        return this;
    }
}
